---
layout: docs
page_title: kv undelete - Command
description: |-
  The "kv undelete" command undeletes the data for the provided version and path
  in the key-value store. This restores the data, allowing it to be returned on
  get requests.
---

# kv undelete

~> **NOTE:** This is a [K/V Version 2](/vault/docs/secrets/kv/kv-v2) secrets
engine command, and not available for Version 1.

The `kv undelete` command undoes the deletes of the data for the provided version
and path in the key-value store. This restores the data, allowing it to be
returned on get requests.

## Examples

Undelete version 3 of the key "creds":

```shell-session
$ vault kv undelete -mount=secret -versions=3 creds
Success! Data written to: secret/undelete/creds
```

## Usage

There are no flags beyond the [standard set of flags](/vault/docs/commands)
included on all commands.

### Output options

- `-format` `(string: "table")` - Print the output in the given format. Valid
  formats are "table", "json", or "yaml". This can also be specified via the
  `VAULT_FORMAT` environment variable.

### Command options

- `-mount` `(string: "")` - Specifies the path where the KV backend is mounted. 
  If specified, the next argument will be interpreted as the secret path. If 
  this flag is not specified, the next argument will be interpreted as the 
  combined mount path and secret path, with /data/ automatically inserted for 
  KV v2 secrets.

- `-versions` `([]int: <required>)` - Specifies the version number that should
  be made current again.
